﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinChart;

namespace ChartAxisLabelAngleBug
{
    public partial class Form1 : Form
    {
        class ParetoData
        {
            public String Name { get; set; }
            public int Quantity { get; set; }
        }

        List<ParetoData> _data1 = new List<ParetoData>();
        List<ParetoData> _data2 = new List<ParetoData>();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            _data1.Add(new ParetoData() { Name = "Col1", Quantity = 1 });
            _data1.Add(new ParetoData(){Name="Col2", Quantity=2});
            _data1.Add(new ParetoData(){Name="Col3", Quantity=3});
            ultraChart1.Data.SwapRowsAndColumns = true;
            ultraChart1.Data.ZeroAligned = true;
            //ultraChart1.Data.DataMember = "Quantity"; // NB: This doesn't seem to work, it always uses the FIRST numeric column!
            ultraChart1.DataSource = _data1;

            _data2.Add(new ParetoData() { Name = "Col1", Quantity = 1 });
            ultraChart2.Data.SwapRowsAndColumns = true;
            ultraChart2.Data.ZeroAligned = true;
            //ultraChart2.Data.DataMember = "Quantity"; // NB: This doesn't seem to work, it always uses the FIRST numeric column!
            ultraChart2.DataSource = _data2;

            checkBox1.Checked = false;
            AngleLabels(ultraChart1, checkBox1.Checked);
            AngleLabels(ultraChart2, checkBox1.Checked);
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            AngleLabels(ultraChart1, checkBox1.Checked);
            AngleLabels(ultraChart2, checkBox1.Checked);
        }

        void AngleLabels(UltraChart chart, Boolean angleLabels)
        {
            if (angleLabels)
            {
                // change X axis labels to lie at an angle
                chart.Axis.X.Labels.Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation.Custom;
                chart.Axis.X.Labels.OrientationAngle = 30;
                chart.Axis.X.Labels.VerticalAlign = StringAlignment.Far;
                chart.Axis.X.Labels.HorizontalAlign = StringAlignment.Near;
            }
            else
            {
                chart.Axis.X.Labels.Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation.VerticalLeftFacing;
                chart.Axis.X.Labels.OrientationAngle = 0;
                chart.Axis.X.Labels.VerticalAlign = StringAlignment.Center;
                chart.Axis.X.Labels.HorizontalAlign = StringAlignment.Near;
            }
        }
    }
}
